---
title: Basic usage of canvas
slug: Web/API/Canvas_API/Tutorial/Basic_usage
tags:
  - Canvas
  - Graphics
  - HTML
  - Intermediate
  - Tutorial
---
<div>{{CanvasSidebar}} {{PreviousNext("Web/API/Canvas_API/Tutorial", "Web/API/Canvas_API/Tutorial/Drawing_shapes")}}</div>

<div class="summary">
<p>Let's start this tutorial by looking at the {{HTMLElement("canvas")}} {{Glossary("HTML")}} element itself. At the end of this page, you will know how to set up a canvas 2D context and have drawn a first example in your browser.</p>
</div>

<h2 id="The_&lt;canvas&gt;_element">The <code>&lt;canvas&gt;</code> element</h2>

<pre class="brush: html">&lt;canvas id="tutorial" width="150" height="150"&gt;&lt;/canvas&gt;
</pre>

<p>At first sight a {{HTMLElement("canvas")}} looks like the {{HTMLElement("img")}} element, with the only clear difference being that it doesn't have the <code>src</code> and <code>alt</code> attributes. Indeed, the <code>&lt;canvas&gt;</code> element has only two attributes, {{htmlattrxref("width", "canvas")}} and {{htmlattrxref("height", "canvas")}}. These are both optional and can also be set using {{Glossary("DOM")}} <a href="/en-US/docs/Web/API/HTMLCanvasElement">properties</a>. When no <code>width</code> and <code>height</code> attributes are specified, the canvas will initially be <strong>300 pixels</strong> wide and <strong>150 pixels</strong> high. The element can be sized arbitrarily by {{Glossary("CSS")}}, but during rendering the image is scaled to fit its layout size: if the CSS sizing doesn't respect the ratio of the initial canvas, it will appear distorted.</p>

<div class="note">
<p><strong>Note:</strong> If your renderings seem distorted, try specifying your <code>width</code> and <code>height</code> attributes explicitly in the <code>&lt;canvas&gt;</code> attributes, and not using CSS.</p>
</div>

<p>The <a href="/en-US/docs/Web/HTML/Global_attributes/id"><code>id</code></a> attribute isn't specific to the <code>&lt;canvas&gt;</code> element but is one of the <a href="/en-US/docs/Web/HTML/Global_attributes">global HTML attributes</a> which can be applied to any HTML element (like <code><a href="/en-US/docs/Web/HTML/Global_attributes/class">class</a></code> for instance). It is always a good idea to supply an <code>id</code> because this makes it much easier to identify it in a script.</p>

<p>The <code>&lt;canvas&gt;</code> element can be styled just like any normal image ({{cssxref("margin")}}, {{cssxref("border")}}, {{cssxref("background")}}…). These rules, however, don't affect the actual drawing on the canvas. We'll see how this is done in a <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Applying_styles_and_colors">dedicated chapter</a> of this tutorial. When no styling rules are applied to the canvas it will initially be fully transparent.</p>

<div id="section_2">
<h3 id="Fallback_content">Fallback content</h3>

<p>The <code>&lt;canvas&gt;</code> element differs from an {{HTMLElement("img")}} tag in that, like for {{HTMLElement("video")}}, {{HTMLElement("audio")}}, or {{HTMLElement("picture")}} elements, it is easy to define some fallback content, to be displayed in older browsers not supporting it, like versions of Internet Explorer earlier than version 9 or textual browsers. You should always provide fallback content to be displayed by those browsers.</p>

<p>Providing fallback content is very straightforward: just insert the alternate content inside the <code>&lt;canvas&gt;</code> element. Browsers that don't support <code>&lt;canvas&gt;</code> will ignore the container and render the fallback content inside it. Browsers that do support <code>&lt;canvas&gt;</code> will ignore the content inside the container, and just render the canvas normally.</p>

<p>For example, we could provide a text description of the canvas content or provide a static image of the dynamically rendered content. This can look something like this:</p>

<pre class="brush: html">&lt;canvas id="stockGraph" width="150" height="150"&gt;
  current stock price: $3.15 + 0.15
&lt;/canvas&gt;

&lt;canvas id="clock" width="150" height="150"&gt;
  &lt;img src="images/clock.png" width="150" height="150" alt=""/&gt;
&lt;/canvas&gt;
</pre>

<p>Telling the user to use a different browser that supports canvas does not help users who can't read the canvas at all, for example. Providing a useful fallback text or sub DOM helps to <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Hit_regions_and_accessibility">make the canvas more accessible</a>.</p>

<h3 id="Required_&lt;canvas&gt;_tag">Required <code>&lt;/canvas&gt;</code> tag</h3>

<p>As a consequence of the way fallback is provided, unlike the {{HTMLElement("img")}} element, the {{HTMLElement("canvas")}} element <strong>requires</strong> the closing tag (<code>&lt;/canvas&gt;</code>). If this tag is not present, the rest of the document would be considered the fallback content and wouldn't be displayed.</p>

<p>If fallback content is not needed, a simple <code>&lt;canvas id="foo" ...&gt;&lt;/canvas&gt;</code> is fully compatible with all browsers that support canvas at all.</p>

<h2 id="The_rendering_context">The rendering context</h2>

<p>The {{HTMLElement("canvas")}} element creates a fixed-size drawing surface that exposes one or more <strong>rendering contexts</strong>, which are used to create and manipulate the content shown. In this tutorial, we focus on the 2D rendering context. Other contexts may provide different types of rendering; for example, <a href="/en-US/docs/Web/WebGL">WebGL</a> uses a 3D context based on <a class="external" href="http://www.khronos.org/opengles/" rel="external" title="http://en.wikipedia.org/wiki/OpenGL_ES">OpenGL ES</a>.</p>

<p>The canvas is initially blank. To display something, a script first needs to access the rendering context and draw on it. The {{HTMLElement("canvas")}} element has a method called {{domxref("HTMLCanvasElement.getContext", "getContext()")}}, used to obtain the rendering context and its drawing functions. <code>getContext()</code> takes one parameter, the type of context. For 2D graphics, such as those covered by this tutorial, you specify <code>"2d"</code> to get a {{domxref("CanvasRenderingContext2D")}}.</p>

<pre class="brush: js">var canvas = document.getElementById('tutorial');
var ctx = canvas.getContext('2d');
</pre>

<p>The first line in the script retrieves the node in the DOM representing the {{HTMLElement("canvas")}} element by calling the {{domxref("document.getElementById()")}} method. Once you have the element node, you can access the drawing context using its <code>getContext()</code> method.</p>

<div id="section_5">
<h2 id="Checking_for_support">Checking for support</h2>

<p>The fallback content is displayed in browsers which do not support {{HTMLElement("canvas")}}. Scripts can also check for support programmatically by testing for the presence of the <code>getContext()</code> method. Our code snippet from above becomes something like this:</p>

<pre class="brush: js">var canvas = document.getElementById('tutorial');

if (canvas.getContext) {
  var ctx = canvas.getContext('2d');
  // drawing code here
} else {
  // canvas-unsupported code here
}
</pre>
</div>
</div>

<h2 id="A_skeleton_template">A skeleton template</h2>

<p>Here is a minimalistic template, which we'll be using as a starting point for later examples.</p>

<div class="note">
<p><strong>Note:</strong> it is not good practice to embed a script inside HTML. We do it here to keep the example concise.</p>
</div>

<pre class="brush: html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
  &lt;head&gt;
    &lt;meta charset="utf-8"/&gt;
    &lt;title&gt;Canvas tutorial&lt;/title&gt;
    &lt;script type="text/javascript"&gt;
      function draw() {
        var canvas = document.getElementById('tutorial');
        if (canvas.getContext) {
          var ctx = canvas.getContext('2d');
        }
      }
    &lt;/script&gt;
    &lt;style type="text/css"&gt;
      canvas { border: 1px solid black; }
    &lt;/style&gt;
  &lt;/head&gt;
  &lt;body onload="draw();"&gt;
    &lt;canvas id="tutorial" width="150" height="150"&gt;&lt;/canvas&gt;
  &lt;/body&gt;
&lt;/html&gt;
</pre>

<p>The script includes a function called <code>draw()</code>, which is executed once the page finishes loading; this is done by listening for the {{event("load")}} event on the document. This function, or one like it, could also be called using {{domxref("WindowTimers.setTimeout", "window.setTimeout()")}}, {{domxref("WindowTimers.setInterval", "window.setInterval()")}}, or any other event handler, as long as the page has been loaded first.</p>

<p>Here is how a template would look in action. As shown here, it is initially blank.</p>

<p>{{EmbedLiveSample("A_skeleton_template", 160, 160)}}</p>

<h2 id="A_simple_example">A simple example</h2>

<p>To begin, let's take a look at a simple example that draws two intersecting rectangles, one of which has alpha transparency. We'll explore how this works in more detail in later examples.</p>

<pre class="brush: html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
 &lt;head&gt;
  &lt;meta charset="utf-8"/&gt;
  &lt;script type="application/javascript"&gt;
    function draw() {
      var canvas = document.getElementById('canvas');
      if (canvas.getContext) {
        var ctx = canvas.getContext('2d');

        ctx.fillStyle = 'rgb(200, 0, 0)';
        ctx.fillRect(10, 10, 50, 50);

        ctx.fillStyle = 'rgba(0, 0, 200, 0.5)';
        ctx.fillRect(30, 30, 50, 50);
      }
    }
  &lt;/script&gt;
 &lt;/head&gt;
 &lt;body onload="draw();"&gt;
   &lt;canvas id="canvas" width="150" height="150"&gt;&lt;/canvas&gt;
 &lt;/body&gt;
&lt;/html&gt;
</pre>

<p>This example looks like this:</p>

<p>{{EmbedLiveSample("A_simple_example", 160, 160, "https://mdn.mozillademos.org/files/228/canvas_ex1.png")}}</p>

<p>{{PreviousNext("Web/API/Canvas_API/Tutorial", "Web/API/Canvas_API/Tutorial/Drawing_shapes")}}</p>
